/*
 * Simular.java
 *
 * Created on 22 de noviembre de 2004, 10:35
 */
import java.lang.*;
import java.io.*;
/**
 *
 * @author  Oscar
 */
public class Simular extends Thread {
  private static simuredJava Princ;
  private static Dibujo dib;
  public Simula HiloSim;
  private static boolean Hecho = false;
  private static boolean pausa = false;
  private static boolean PasoaPaso = false;
  
  public Simular() {
    setName("Simular");
  }
  
  /**
   * Funcion de Simulacion
   */
  public void run(){
    int ndir, adelanto, numpaq, pp;
    int paqlong;
    int puntos, puntos2, plleva, plleva2;
    // int SimuVar, SimuVar2; /* Estas son las de F. Pardo
    //boolean SimuVar; // Pues solo hay una eleccion en VariableRad
    String SimuVar2mia;
    int SimuVar2, SimuVar;
    int dimensiones, nodosdim, lonbuffer, nvirtuales;
    int noleelong;
    int valoraux;
    double tasaemit;
    double LaVar, LaVarIni, LaVarFin;
    double LaVar2, LaVarIni2, LaVarFin2;
    Red redaux;
    String TrazaName, msgaux;
    File fich = null, f = null;
    FileWriter out = null;
    //InputStreamReader in = null;
    String auxi = null;
    Cronometro crono = new Cronometro();
    crono.start();
    
    System.out.println("");
    System.out.println("NUEVA SIMULACION ************************************************");
    
    if(Princ.SimuStop == false){
      System.out.println("Esto no deberia aparecer. (Simulacion dentro de otra)");
    }
    Princ.SimuStop = false;
    Hecho = false; // Ponemos a false la vble para Interrumpir la Simulacion
    if(Princ.GuardarCheck.isSelected()){
      auxi = Princ.ResultFichTxt.getSelectedItem().toString();
      if(auxi!=" "){
        f = new File(auxi);
        if(Princ.AnyadeCheck.isSelected())
          try{
            out = new FileWriter(f, true);
          } catch(IOException e){
            System.err.println(" Exception en FileWriter");
            System.exit(1);
          } else
            try{
              out = new FileWriter(f);
            } catch(IOException e){
              System.err.println(" Exception en FileWriter");
              System.exit(1);
            }
      } else
        if(Princ.Idioma()== 1)
          System.out.println("No se ha especificado un fichero de Resultados\n");
        else
          System.out.println("There is no Result File specification\n");
    }
    if (Princ.Interactiva){
      // Interactiva
      SimuVar2 = 0;
      LaVarIni2 = 0.0;
      LaVarFin2 = 0.0;
      LaVar2 = 0.0;
      puntos2 = 1;
    } else{
      // Multiple
      SimuVar2 = Princ.SimuVar2Int;
      LaVarIni2 = Double.parseDouble(Princ.Ini2Txt.getSelectedItem().toString());
      LaVarFin2 = Double.parseDouble(Princ.Fin2Txt.getSelectedItem().toString());
      //LaVarFin2 = new Double(Fin2Txt.getSelectedItem().toString()).doubleValue();
      LaVar2 = LaVarIni2;
      if(SimuVar2!=0)
        puntos2 = Integer.parseInt(Princ.Puntos2Txt.getSelectedItem().toString());
      //puntos2 = new Integer(Puntos2Txt.getSelectedItem().toString()).intValue();
      else
        puntos2 = 1;
    }
    TrazaName ="";
    fich = null;
    if(Princ.TrazasCheck.isSelected()){
      if(Princ.TrazaFichTxt.getSelectedItem().toString()!=""){
        TrazaName = Princ.TrazaFichTxt.getSelectedItem().toString();
        fich = new File(TrazaName);
      } else
        if(Princ.Idioma()== 1)
          System.out.println("NO se ha especificado un fichero de Trazas");
        else
          System.out.println("There is NO trace file specification");
    }
    if (Princ.BidirCheck.isSelected())
      ndir = 2;
    else
      ndir = 1;
    if(Princ.AdelantoCheck.isSelected())
      adelanto = 1;
    else
      adelanto = 0;
    if (Princ.NumPaqRad.isSelected())
      numpaq = Integer.parseInt(Princ.NumPaqTxt.getSelectedItem().toString());
    //numpaq = new Integer(NumPaqTxt.getSelectedItem().toString()).intValue();
    else
      //numpaq = new Integer(NumFlitTxt.getSelectedItem().toString()).intValue()*new Integer(DimTxt.getSelectedItem().toString()).intValue()*new Integer(NodosTxt.getSelectedItem().toString()).intValue()/new Integer(LonPaqTxt.getSelectedItem().toString()).intValue();
      numpaq = Integer.parseInt(Princ.NumFlitTxt.getSelectedItem().toString())*Integer.parseInt(Princ.DimTxt.getSelectedItem().toString())*Integer.parseInt(Princ.NodosTxt.getSelectedItem().toString())/Integer.parseInt(Princ.LonPaqTxt.getSelectedItem().toString());
    paqlong = Integer.parseInt(Princ.LonPaqTxt.getSelectedItem().toString());
    tasaemit = Double.parseDouble(Princ.EmisionTxt.getSelectedItem().toString());
    dimensiones = Integer.parseInt(Princ.DimTxt.getSelectedItem().toString());
    nodosdim = Integer.parseInt(Princ.NodosTxt.getSelectedItem().toString());
    lonbuffer = Integer.parseInt(Princ.FifoTxt.getSelectedItem().toString());
    nvirtuales = Integer.parseInt(Princ.VirtualesTxt.getSelectedItem().toString());
    plleva2 = 0;
    while ((plleva2 < puntos2) && (Princ.Continuar!= 3)){
      plleva2++;
      msgaux = "Item";
      if(Princ.Interactiva){
        // Interactiva
        SimuVar = 0;
        LaVarIni = 0.0;
        LaVarFin = 0.0;
        LaVar = Double.parseDouble(Princ.EmisionTxt.getSelectedItem().toString());
        puntos = 1;
        msgaux = "Item";
      } else{
        // Multiple
        SimuVar = 0;
        LaVarIni = Double.parseDouble(Princ.IniTxt.getSelectedItem().toString());
        LaVarFin = Double.parseDouble(Princ.FinTxt.getSelectedItem().toString());
        LaVar = LaVarIni;
        puntos = Integer.parseInt(Princ.PuntosTxt.getSelectedItem().toString());
        if(SimuVar2!=0){
          switch (SimuVar2){
            case 1: msgaux = "dimensiones";break;
            case 2: msgaux = "Nodos por Dimension";break;
            case 3: msgaux = "Numero de Canales Virtuales";break;
            case 4: msgaux = "Longitud del Buffer";break;
          }
        }
      }
      switch (SimuVar2){
        case 1: dimensiones = (int)LaVar2; break;
        case 2: nodosdim = (int)LaVar2; break;
        case 4: lonbuffer = (int)LaVar2; break;
        case 3: nvirtuales = (int)LaVar2; break;
      }
      plleva = 0;
      while((plleva < puntos) && (Princ.Continuar!=3)){
        plleva++;
                /*    if(TrazaName!=""){
                        try{
                            in = new FileReader(fich);
                        }
                        catch(IOException e){
                            System.err.println(" Exception al crear filewriter out2");
                            System.exit(1);
                        }
                    }
                 */
        if (fich!= null)
          puntos = 1; // solo uno
        if(SimuVar == 0)
          tasaemit = LaVar;
        redaux = Princ.LaRedGlobal;
        Princ.LaRedGlobal = null; // previene accesos indeseados mientras se destruye y se vuelve a crear
        if(redaux!= null)
          redaux = null;
        redaux = new Red(dimensiones,
            nodosdim,
            nvirtuales,
            lonbuffer,
            ndir,
            adelanto,
            Princ.FisicoCheck.isSelected(),
            Princ.RoutingTxt.getSelectedIndex(),
            Princ.ConmutTxt.getSelectedIndex(),
            Integer.parseInt(Princ.LatFifoTxt.getSelectedItem().toString()),
            Integer.parseInt(Princ.LatCrossTxt.getSelectedItem().toString()),
            Integer.parseInt(Princ.LatCanalTxt.getSelectedItem().toString()),
            Integer.parseInt(Princ.LatConmutTxt.getSelectedItem().toString()),
            Integer.parseInt(Princ.DummyUpPackTxt.getSelectedItem().toString()));
        Princ.LaRedGlobal = redaux; // Ahora ya esta creada
        Princ.Muestra("----------------------------------");
        // if(Princ.Interactiva)
        Princ.Muestra("Item: "+plleva+", Variable: "+LaVar);
        if(Princ.LongitCheck.isSelected())
          noleelong = 1;
        else
          noleelong = 0;
        valoraux= plleva;
        if(!Princ.Interactiva)
          if(SimuVar2>0)
            valoraux = (int)LaVar2;
        if(f!= null){
          if ( ((Princ.RadFinal.isSelected()) && (plleva==1)) || Princ.RadContinuous.isSelected() ){
            if(Princ.Idioma() == 1){
              try{
                out.write("\""+msgaux+"\";");
                out.write("\"Ciclos\";\"Paquetes enviados\";\"Paquetes recibidos\";\"Tasa envio (flits/nodo/ciclo)\";\"Tasa recepcion (flits/nodo/ciclo)\";\"Latencia Cabecera\";\"Latencia Cabecera (sin bloqueos)\";\"Latencia Paquete\";\"Latencia Paquete (sin bloqueos)\";\"Ciclos de Bloqueo\";\"Camino Medio (nodos)\"\n");
              } catch(IOException e){
                System.err.println(" Exception al escribir en f");
                System.exit(1);
              }
            } else if(Princ.Idioma() == 0){
              try{
                out.write("\""+msgaux+"\";");
                out.write("\"Cycles\";\"Delivered packets\";\"Received packets\";\"Delivery rate (flits/node/cycle)\";\"Arrival rate (flits/node/cycle)\";\"Head Latency\";\"Head Latency (no locks)\";\"Packet Latency\";\"Packet Latency (no locks)\";\"Lock cycles\";\"Average Path (nodes)\"\n");
              } catch(IOException e){
                System.err.println(" Exception al escribir en f");
                System.exit(1);
              }
            }
          }
        }
        ////////////////////////////////////
        /////////// SIMULA /////////////////
        ////////////////////////////////////
        pp = Integer.parseInt(Princ.LonCabTxt.getSelectedItem().toString());
        HiloSim = new Simula(Princ,fich, out, paqlong, pp, numpaq+Princ.LaRedGlobal.NumPackDummy, (float)tasaemit, Princ.Continuar, noleelong, valoraux, this);
        HiloSim.start();
        try{
          HiloSim.join();
        } catch(java.lang.InterruptedException e){
          System.err.println("Exception en llamada a Join simula "+e);
        }
        //f Princ.LaRedGlobal.lanzador.Termina();
        Princ.ShowStats(0);
        if (Princ.RadFinal.isSelected())
          Princ.PrintStatsToFile(out, valoraux,0);
        Princ.Muestra("");
        if (puntos>1){
          if (Princ.jRadioButton4.isSelected()) // linear
            LaVar = LaVar+(LaVarFin-LaVarIni)/(puntos-1);
          else
            LaVar = LaVar*Math.pow(LaVarFin/LaVarIni, 1.0/(puntos-1));
        }
 /*                      if(fich!=null){
                           try{
                                fich.close();
                           }
                           catch(IOException e){
                                System.err.println(" Exception al cerrar fichero trazas");
                                System.exit(1);
                            }
                       }*/
      }
      if (puntos2> 1){
        if (Princ.jRadioButton6.isSelected())
          LaVar2 = LaVar2+(LaVarFin2-LaVarIni2)/(puntos2-1);
        else
          LaVar2 = LaVar2*Math.pow((LaVarFin2/LaVarIni2), 1.0/(puntos2-1));
      }
    }
    
    if (Princ.Continuar!= 3){
      if(!Princ.NoDibujes){
                /*if(dib.idio == 1)
                    dib.jLabel2.setText("SIMULACION COMPLETADA");
                else
                    dib.jLabel2.setText("SIMULATION COMPLETED");
                 */
        Princ.Dibuja(Princ.LaRedGlobal);
        dib.bGoOtro.setEnabled(true);
        dib.bDetenerOtro.setEnabled(false);
        dib.bPausa.setEnabled(false);
        dib.bPaso.setEnabled(dib.MostrarCheck.isSelected());
        dib.MostrarCheck.setEnabled(true);
      } else{
        if(!Princ.InteractCheck.isSelected())
          Princ.InteractCheck.setEnabled(true);
        Princ.bGo.setEnabled(true);
        Princ.bDetener.setEnabled(false);
      }
      
      if(Princ.Idioma() == 1)
        Princ.Muestra("SIMULACION COMPLETADA CON EXITO.");
      else if(Princ.Idioma() == 0)
        Princ.Muestra("SIMULATION SUCCESSFULLY FINISHED.");
    } else{
      if(Princ.Idioma() == 1)
        Princ.Muestra("SIMULACION INTERRUMPIDA. Ver mensajes anteriores y la Red");
      else if(Princ.Idioma() == 0)
        Princ.Muestra("SIMULATION INTERRUPTED. See last messages and the network.");
    }
    
    if(f!= null){
      try{
        out.close();
      } catch(IOException e){
        System.err.println(" Exception al cerrar filewriter out");
        System.exit(1);
      }
    }
    Princ.Continuar = 0;
    Princ.SimuStop = true;
    // Liberamos memoria (puede ser util)
    //System.gc();
    
    System.out.println(Princ.LaRedGlobal.NumPackTrans+" de "+Princ.LaRedGlobal.NumPackEmit+" FIN SIMULACION ************************************************");
    System.out.println("");
    crono.end();
    System.out.println("Tiempo de simulacion: "+(crono.duration()/1000.0)+" segundos");
    System.runFinalization();
    System.gc();
    
    
  }
  
  
  /**
   * Cambia Vble para terminar el Hilo
   */
  public void setHecho(){
    Hecho = true;
  }
  
  public void setNotHecho(){
    Hecho = false;
  }
  /**
   * Devuelve el valor de la Vble
   */
  public boolean getHecho(){
    return Hecho;
  }
  /**
   * Cambia Vble para Pausar un Hilo
   */
  public void setSleep(){
    pausa = true;
  }
  
  /**
   * Cambia Vble pausa a False
   */
  public void setNotSleep(){
    pausa = false;
  }
  /**
   * Devuelve el valor de la vble pausa
   */
  public boolean getSleep(){
    return pausa;
  }
  
  public void setPaso(){
    PasoaPaso = true;
  }
  public boolean getPaso(){
    return PasoaPaso;
  }
  public void setNotPaso(){
    PasoaPaso = false;
  }
  
  /** Creates a new instance of Simular */
  public Simular(simuredJava f, Dibujo dibu) {
    Princ = f;
    dib = dibu;
    
  }
  
}
