/*
 * Node.java
 *
 * Created on 24 de septiembre de 2004, 11:19
 */

/**
 *
 * @author  Oscar
 */
public class Node {
    private Red LaRed;
    /** Los Buffers NumBuf internos in */
    public miBuffer[] Buf_in; 
    /** Los Buffers NumBuf internos out */
    public miBuffer[] Buf_out;
    public CrossBar ElCrossBar;
    public Processor ElProcOut = new Processor();
    public Processor ElProcIn = new Processor();
    
    /** Creates a new instance of Node */
    public Node(Red unared){
        int i;
        LaRed = unared;
        Buf_in = new miBuffer[LaRed.NumBuf+LaRed.NumVirtuals]; // Tantos internos como virtuales haya
        Buf_out = new miBuffer[LaRed.NumBuf+LaRed.NumVirtuals];
      
        for(i = 0; i < (LaRed.NumBuf+LaRed.NumVirtuals); i++){
            Buf_in[i] = new miBuffer(LaRed, i);
            Buf_out[i] = new miBuffer(LaRed, i);
        }
        ElCrossBar = new CrossBar(LaRed);
        // Conectamos los buffers de entrada con el CrossBar
        for(i = 0; i <(LaRed.NumBuf+LaRed.NumVirtuals); i++){
            Buf_in[i].Fifo[LaRed.NumFlitBuf-1].Next = (CrossSwitch)ElCrossBar.Output[i];
            ElCrossBar.Output[i].Prev =(FifoFlit)Buf_in[i].Fifo[LaRed.NumFlitBuf-1];
        }
        // Los Switches sobre la marcha (dinamicos)
        // El buffer interno de salida se conecta al procesador
      // ElProcOut = new Processor();
       //ElProcIn = new Processor();
        for(i = 0; i < LaRed.NumVirtuals; i++){
            Buf_out[LaRed.NumBuf+i].Fifo[LaRed.NumFlitBuf-1].Next = ElProcOut;
            Buf_in[LaRed.NumBuf+i].Fifo[0].Prev = ElProcIn;
        }
        
        ElProcOut.Prev = (FifoFlit)Buf_out[LaRed.NumBuf].Fifo[LaRed.NumFlitBuf-1];
        ElProcIn.Next = (FifoFlit)Buf_in[LaRed.NumBuf].Fifo[0]; // pero valen el resto tambien
    }
 /*   
 protected void finalize(){
     int i=0, j=0;
      for(i = 0; i < (LaRed.NumBuf+LaRed.NumVirtuals); i++){
            Buf_in[i]= null;
            Buf_out[i] = null;
        }
     Buf_in = null;
     Buf_out = null;
     
     ElProcOut = null;
     ElProcIn = null;
 }
 */
}
