/*
 * Simula.java
 *
 * Created on 24 de noviembre de 2004, 14:42
 */
import java.io.*;
import java.lang.*;
import java.math.*;
import java.util.*;
import java.util.concurrent.*;
/**
 *
 * @author  Oscar
 */
public class Simula extends Thread{
  private static simuredJava princ;
//     private InputStreamReader fich;
  private File fich;
  private FileWriter f;
  private Simular ThreadPadre;
  private int paqlong;
  private int cablong;
  private int Tope;
  private float TasaEmit;
  private int continuar;
  private int noleelong;
  private int valorval;
  
  /** Creates a new instance of Simula */
  public Simula(simuredJava Princ, File Fich, FileWriter F,int Paqlong, int Cablong, int tope, float tasaEmit, int Continuar, int Noleelong, int ValorVal, Simular hilo ){
    setName("Simula");
    // setPriority(MAX_PRIORITY);
    princ = Princ;
    fich = Fich;
    f = F;
    paqlong = Paqlong;
    cablong = Cablong;
    Tope = tope;
    TasaEmit = tasaEmit;
    continuar = Continuar;
    noleelong = Noleelong;
    valorval = ValorVal;
    ThreadPadre = hilo;
  }
  /** Funcion que simula un conjunto de paquetes
   * con las condiciones que se le pasan
   */
  public synchronized void run(){
    int orig=0, dest=0;
    int CicloFich,FinFich,milongit=0,CicloPack,IdPack;
    int SucRead;
    String CicloTxt,LongId1,LongId2;
    int packpunt;
    float Tasaux;    // paquete/ciclo
    String linea;
    boolean contsimu;
    InputStreamReader talfich;
    int myCycles;
    int cont = 0;
    
    Random random = new Random();
    TasaEmit =(float) 1.0*TasaEmit*princ.LaRedGlobal.NumNodes/paqlong; // Solo consideramos datos
    //princ.Dibuja(princ.LaRedGlobal);
    
    BufferedReader in = null;
    if (fich!=null){
      try{
        talfich = new FileReader(fich);
        in = new BufferedReader(talfich);
        
        
        
        if (in!=null) {
          // first trace pass to see dependent packets
          Tope=0;
          FinFich=0;
          while (FinFich==0) {
            CicloPack=-1;
            CicloFich=-1;
            IdPack=-1;
            if ((linea=in.readLine())!=null) {
              if (!linea.startsWith("#"))  // comentario
              {
                milongit=paqlong+cablong;
                String[] result = linea.split("\\s");
                SucRead=result.length;
                //SucRead=sscanf(linea,"%s %d %d %s %s",CicloTxt,orig,dest,LongId1,LongId2);
                if (SucRead<3) FinFich=1;
                else{
                  FinFich=0;
                  if (result[0].startsWith("p")) CicloPack=Integer.parseInt(result[0].substring(1));
                  else CicloFich=Integer.parseInt(result[0]);
                  orig=Integer.parseInt(result[1]);
                  dest=Integer.parseInt(result[2]);
                  if (SucRead==4){
                    if (result[3].startsWith("p")) IdPack=Integer.parseInt(result[3].substring(1));
                    else milongit=Integer.parseInt(result[3]);
                  }
                  if (SucRead==5){
                    if (result[4].startsWith("p")) IdPack=Integer.parseInt(result[4].substring(1));
                    else milongit=Integer.parseInt(result[4]);
                  }
                  if (noleelong!=0) milongit=paqlong+cablong;
                }
              }
            } else {
              FinFich=1;
            }
            if (FinFich==0) {
              if (CicloFich>=0) Tope++;
              if (CicloPack>=0) {
                Tope++;
                // Creates dependent packet
                princ.LaRedGlobal.InsertTracePack(CicloPack,orig,dest,milongit,IdPack);
              }
            }
          }
          in.close();
          talfich.close();
        }
      }catch(IOException e){
        System.err.println(" Exception al cerrar filewriter out");
        System.exit(1);
      }
    }
// reopen fich to read the remaining traces
    in = null;
    if (fich!=null)
      try{
        talfich = new FileReader(fich);
        in = new BufferedReader(talfich);
      } catch(IOException e){
        System.err.println(" Exception al crear filereader out2");
        System.exit(1);
      }
    
    packpunt=Tope/Integer.parseInt(princ.StatPointsTxt.getSelectedItem().toString());
    CicloFich=-1;
    CicloPack=-1;
    IdPack=-1;
    FinFich=0;
    myCycles=0;
    contsimu=true;
    do
    {
      //while(((princ.LaRedGlobal.NumPackTrans<princ.LaRedGlobal.NumPackEmit) || (FinFich == 0))&&(!ThreadPadre.getHecho())){
      //n paquetes y se para
      if(ThreadPadre.getSleep()){
        try{
          this.currentThread().wait();
        }catch(java.lang.InterruptedException e){
          System.err.println("Exception en Wait de Simula: "+e);
        }
      }
      
      // Crea los paquetes de este ciclo
      if(fich== null){
        Tasaux = TasaEmit;
        if ((princ.LaRedGlobal.NumPackCreated[0]-princ.LaRedGlobal.NumPackEmit[0])<5*princ.LaRedGlobal.NumNodes*princ.LaRedGlobal.NumVirtuals)
          while(Tasaux>0){
          if (random.nextFloat()<Tasaux){
            orig = Math.abs(random.nextInt())%princ.LaRedGlobal.NumNodes;
            do
              dest = Math.abs(random.nextInt())%princ.LaRedGlobal.NumNodes;
            while (dest == orig);
            new Packet(princ.LaRedGlobal, paqlong+cablong, orig, dest,-1);
          }
          Tasaux--;
          }
      } else{
        //Paquetes de un fichero
        if(FinFich == 0){
          do{
            try{
              if (CicloFich==-1){
                IdPack=-1;
                if ((linea=in.readLine())!=null) {
                  if (!linea.startsWith("#"))  // comentario
                  {
                    milongit=paqlong+cablong;
                    String[] result = linea.split("\\s");
                    SucRead=result.length;
                    //SucRead=sscanf(linea,"%s %d %d %s %s",CicloTxt,orig,dest,LongId1,LongId2);
                    if (SucRead<3) FinFich=1;
                    else{
                      FinFich=0;
                      if (result[0].startsWith("p")) CicloPack=Integer.parseInt(result[0].substring(1));
                      else CicloFich=Integer.parseInt(result[0]);
                      orig=Integer.parseInt(result[1]);
                      dest=Integer.parseInt(result[2]);
                      if (SucRead==4){
                        if (result[3].startsWith("p")) IdPack=Integer.parseInt(result[3].substring(1));
                        else milongit=Integer.parseInt(result[3]);
                      }
                      if (SucRead==5){
                        if (result[4].startsWith("p")) IdPack=Integer.parseInt(result[4].substring(1));
                        else milongit=Integer.parseInt(result[4]);
                      }
                      if (noleelong!=0) milongit=paqlong+cablong;
                    }
                  }
                } else {
                  FinFich=1;
                }
              }
              if (FinFich==1) break;
              // creates packet
              if (CicloFich==myCycles) {
                new Packet(princ.LaRedGlobal,milongit,orig,dest,IdPack);
                CicloFich=-1;
              } else if (CicloPack>=0) {
                CicloPack=-1; // continues
              }
            } catch(IOException e){
              System.err.println(" Exception al cerrar filewriter out");
              System.exit(1);
            }
          } while(CicloFich<=myCycles);
          if(FinFich == 1){
            princ.LaRedGlobal.CyclesCreation[0]=princ.LaRedGlobal.Cycles[0];
          }
        }
      }
      ///////////////////////////////
      ///////////////////////////////
      try{
        princ.LaRedGlobal.RunCycle(); // Mueve paquetes por la red
      }catch(InterruptedException ie){System.out.println("error en RunCycle Red"+ie);}
      myCycles++;
      ////////////////////////////////
      ////////////////////////////////
      if((princ.LaRedGlobal.BloqueoTotal) && (princ.LaRedGlobal.Packets!=null)){
        princ.Muestra("BLOQUEO MORTAL");
        princ.Continuar = 3;
        break;
      }
      //Controlo el flujo segun continuar
      switch(princ.Continuar){
        case 0: //No muestra nada y sigue
          break; //nada;
        case 1: //Muestra pero se para
          if(!princ.NoDibujes)
            princ.Dibuja(princ.LaRedGlobal);
          while((princ.Continuar == 1)&& (ThreadPadre.getPaso()));
          if(princ.Continuar<3) princ.Continuar = 1;
          break;
        case 2: // No se utiliza, es para salir del bucle anterior
          //   princ.Dibuja(princ.LaRedGlobal);
          //continuar = 1;
          //System.out.println("Continuar nunca vale 2");
          break;
        case 3: // Se termina directamente
          if(!princ.NoDibujes)
            princ.Dibuja(princ.LaRedGlobal);
          if(princ.LaRedGlobal.Cycles[0]>1)
            princ.LaRedGlobal.Cycles[0] = princ.LaRedGlobal.Cycles[0]-2;
          //Ajusta Ciclos
          return;
        default: return;
        
      }
      // finish condition
      if ((princ.LaRedGlobal.NumPackTrans[0]>=Tope) && (princ.RadStopSim0.isSelected())) contsimu=false;
      if ((princ.LaRedGlobal.NumPackEmit[0]>=Tope)  && (princ.RadStopSim1.isSelected())) contsimu=false;
      if (ThreadPadre.getHecho()) contsimu=false;
      // Update counters
      //if (princ.LaRedGlobal.NumPackEmit[0]<princ.LaRedGlobal.NumPackCreated[0])
      //  princ.LaRedGlobal.CyclesEmit[0]=0;
      //else if (princ.LaRedGlobal.CyclesEmit[0]==0)
      //  princ.LaRedGlobal.CyclesEmit[0]=princ.LaRedGlobal.Cycles[0];
      // saves results to a file
      if (princ.GuardarCheck.isSelected() && princ.RadContinuous.isSelected()
      && (princ.LaRedGlobal.NumPackDummy==0)
      && (princ.LaRedGlobal.NumPackTrans[1]>=packpunt) ) {
        princ.PrintStatsToFile(f,valorval,1);
        princ.LaRedGlobal.ResetStatSet(1);
      }
      if ( (princ.LaRedGlobal.BloqueoTotal) && (princ.LaRedGlobal.Packets!=null) ) {
        princ.Muestra("DEADLOCK FOUND!!");
        continuar=3;
        break;
      }
    } while (contsimu);
    if (princ.LaRedGlobal.Cycles[0]>1) princ.LaRedGlobal.Cycles[0]=princ.LaRedGlobal.Cycles[0]-2; // Ajusta ciclos
    if (princ.LaRedGlobal.CyclesEmit[0]==0) princ.LaRedGlobal.CyclesEmit[0]=princ.LaRedGlobal.Cycles[0];
    if (princ.LaRedGlobal.CyclesCreation[0]==0) princ.LaRedGlobal.CyclesCreation[0]=princ.LaRedGlobal.Cycles[0];
    
    // may be I shoulk close talfich and in
    //princ.Dibuja(princ.LaRedGlobal);
    
  }
  
  
  public synchronized void Despierte(){
    ThreadPadre.setNotSleep();
    notify();
  }
}
